<?php

/**
 * Moka Ödeme Kuruluşu A.Ş WHMCS Gateway Module
 * **
 * LÜTFEN ÖNCELİKLE README DOSYASINI OKUYUNUZ
 * **
 * Bu eklenti WHMCS sistemleri üzerinden Kredi Kartı ödemeleri almanızı sağlar.
 * Tamamen açık kaynaklı ve ücretsizdir. Satılamaz. 
 * @copyright Copyright (c) EticSoft R&D Lab Teknokent
 * @license GPL http://www.gnu.org/licenses/gpl-3.0.en.html
 * @see http://moka.com
 * @see http://docs.whmcs.com/Gateway_Module_Developer_Docs
 * Teknik destek için http://eticsoft.com/support 
 *
 */
if (!defined("WHMCS")) {
    die("This file cannot be accessed directly");
}

function eticsoft_mokagateway_MetaData()
{
    return array(
        'DisplayName' => 'Moka Credit Card Gateway Module',
        'APIVersion' => '1.1', // Use API Version 1.1
        'DisableLocalCredtCardInput' => false,
        'TokenisedStorage' => false,
    );
}

function eticsoft_mokagateway_getParams()
{
    $table = "tblpaymentgateways";
    $fields = "setting,value";
    $where = array("gateway" => 'eticsoft_mokagateway');
    $query = select_query($table, $fields, $where);
    $params = array();
    while ($param = mysql_fetch_array($query)) {
        $params[$param['setting']] = $param['value'];
    }
    return $params;
}

function eticsoft_mokagateway_config()
{
    $config_options = array(
        // the friendly display name for a payment gateway should be
        // defined here for backwards compatibility
        'FriendlyName' => array(
            'Type' => 'System',
            'Value' => 'Moka Kredi Kartı İle Ödeme Modülü',
        ),
        'eticsoft_moka_DealerCode' => array(
            'FriendlyName' => 'Moka Bayi Kodu (DealerCode)',
            'Type' => 'text',
            'Size' => '25',
            'Default' => '',
            'Description' => 'Moka Bayi Kodu (DealerCode) Moka hesabınızdan (moka.com) edinebilirsiniz.',
        ),
        'eticsoft_moka_Username' => array(
            'FriendlyName' => 'Kullanıcı Adı (Username)',
            'Type' => 'text',
            'Size' => '60',
            'Default' => '',
            'Description' => 'Kullanıcı Adı (Username) Moka hesabınızdan (moka.com) edinebilirsiniz.',
        ),
        'eticsoft_moka_Password' => array(
            'FriendlyName' => 'Şifre (Password)',
            'Type' => 'text',
            'Size' => '60',
            'Default' => '',
            'Description' => 'Şifre (Password) Moka hesabınızdan (moka.com) edinebilirsiniz.',
        ),
        'eticsoft_moka_3dmode' => array(
            'FriendlyName' => '3D Secure Yönlendirme Modu',
            'Type' => 'dropdown',
            'Options' => array(
                'on' => 'Tüm ödemeleri 3D Secure ile yaptır. (Daha güvenli)',
                'off' => 'Tüm ödemeleri API ile yaptır. (Daha kolay daha hızlı)',
            ),
            'Description' => '3D-Secure yöntemini seçiniz',
        ),
    );

    for ($i = 1; $i < 10; $i++) {
        $config_options[$i . '_installment'] = array(
            'FriendlyName' => ($i == 1 ? 'Tek çekim' : $i . ' taksit') . ' komisyonu',
            'Type' => 'text',
            'Size' => '4',
            'Default' => $i + (0.4) + ($i / 2),
            'Description' => '',
        );
    }

    return $config_options;
}

function eticsoft_mokagateway_validate3d($params)
{
    $params = eticsoft_mokagateway_getParams();
    $dealercode = $params['eticsoft_moka_DealerCode'];
    $username = $params['eticsoft_moka_Username'];
    $password = $params['eticsoft_moka_Password'];
    $tdmode = $params['eticsoft_moka_3dmode'];

    $error_message = false;

    $response = $_POST;

    $record = array(
        'id_cart' => $params['invoice']['id'],
        'id_customer' => $params['invoice']['clientdetails']['userid'],
        'amount' => $response['amount'] / 100,
        'amount_paid' => 0,
        'id_eticsoft_moka' => $response['orderId'],
        'result_code' => $response['errorCode'],
        'result_message' => $response['errorMessage'],
        'result' => false
    );

    $record['result_code'] = $_POST['errorCode'];
    $record['result_message'] = $_POST['errorMessage'];
    $record['id_eticsoft_moka'] = $_POST['orderId'];
    $record['result'] = false;

    $hash_text = $response['orderId']
            . $response['result']
            . $response['amount']
            . $response['mode']
            . $response['errorCode']
            . $response['errorMessage']
            . $response['transactionDate']
            . $response['publicKey']
            . $private_key;
    $hash = base64_encode(sha1($hash_text, true));

    if ($hash != $response['hash']) { // has yanlışsa
        $record['result_message'] = "Hash uyumlu değil";
        return $record;
    }
    if ($response['result'] == 1) { // 3D doğrulama başarılı çekim yap
        try {
            $xml_response = $obj->pay();
        } catch (Exception $e) {
            $record['result_message'].= "Post error after 3DS";
            $record['result_code'] = "8888";
            $record;
            return $record;
        }

        $record['result'] = (string) $xml_response['result'] == '1' ? true : false;
        $record['result_message'] = (string) $xml_response['error_message'];
        $record['result_code'] = (string) $xml_response['error_code'];
    }
    return $record;
}

function eticsoft_mokagateway_capture($params)
{
    global $smarty;


    $_POST['eticsoft_moka_installment'] = isset($_POST['eticsoft_moka_installment']) ? (int) $_POST['eticsoft_moka_installment'] :
            (isset($_SESSION['eticsoft_moka_installment']) ? (int) $_SESSION['eticsoft_moka_installment'] : 1);

    $response = eticsoft_mokagateway_post2Moka($params);
    $smarty->assign('errormessage_eticsoft_moka', $response['result_code'] . ':' . $response['result_message']);

    return array(
        'status' => $response['result'] ? 'success' : 'declined',
        'rawdata' => $response,
        'transid' => $response['id_eticsoft_moka'],
        'fees' => $response['fee'],
        'errormessage' => $response['result_code'] . ':' . $response['result_message'],
        'error' => $response['result_code'] . ':' . $response['result_message'],
    );
}

function eticsoft_mokagateway_post2Moka($params)
{
    $amount = (float) ($params['amount']);
    $ins = (int) $_POST['eticsoft_moka_installment'];
    $ins_rate = (100 + $params[$ins . '_installment']) / 100;
    $amount_pay = $amount * $ins_rate;
    $fee = number_format($amount_pay - $amount, 2);

    $orderid = 'WHMCS' . $params['invoiceid'] . '-' . time();

    $moka_params = eticsoft_mokagateway_getParams();
    $dealercode = $moka_params['eticsoft_moka_DealerCode'];
    $username = $moka_params['eticsoft_moka_Username'];
    $password = $moka_params['eticsoft_moka_Password'];
    $eticsoft_moka_3d_mode = $moka_params['eticsoft_moka_3dmode'];

    // System URL last char slash fix
    $params['systemurl'] .= substr($params['systemurl'], -1) != '/' ? '/' : '';

    $moka['PaymentDealerAuthentication'] = array(
        'DealerCode' => $dealercode,
        'Username' => $username,
        'Password' => $password,
        'CheckKey' => hash('sha256', $dealercode . 'MK' . $username . 'PD' . $password)
    );

    $moka['PaymentDealerRequest'] = array(
        'CardHolderFullName' => $params['clientdetails']['firstname'] . ' ' . $params['clientdetails']['lastname'],
        'CardNumber' => $params['cardnum'],
        'ExpMonth' => substr($params['cardexp'], 0, 2),
        'ExpYear' => "20" . substr($params['cardexp'], -2),
        'CvcNumber' => $params['cccvv'],
        'Amount' => $amount_pay,
        'Currency' => $params['clientdetails']['countrycode'] != 'TRY' ? $params['clientdetails']['countrycode'] : 'TL',
        'InstallmentNumber' => $ins,
        'OtherTrxCode' => (string) $orderid,
        'ClientIP' => $ip,
        'Software' => 'WHMCS',
        'RedirectUrl' => $params['systemurl'] . 'creditcard.php?invoiceid=' . $params['invoiceid'] . '&tdvalidate=1',
        "IntegratorId" => 1
    );


    $record = array(
        'id_cart' => $params['invoiceid'],
        'id_customer' => $params['clientdetails']['userid'],
        'amount' => $amount,
        'amount_paid' => 0,
        'installment' => $ins,
        'fee' => $fee,
        'cc_name' => $moka['PaymentDealerRequest']['CardHolderFullName'],
        'cc_expiry' => $moka['PaymentDealerRequest']['ExpMonth'] . $moka['PaymentDealerRequest']['ExpYear'],
        'cc_number' => substr($moka['PaymentDealerRequest']['CardNumber'], 0, 6) . 'XXXXXXXX' . substr($moka['PaymentDealerRequest']['CardNumber'], -2),
        'id_eticsoft_moka' => $orderid,
        'result_code' => '',
        'result_message' => '',
        'result' => false
    );

    $api_url = "https://service.moka.com/PaymentDealer/DoDirectPayment";

    if ($eticsoft_moka_3d_mode == 'off') {
        $result = json_decode(eticsoft_mokagateway_curlPostExt(json_encode($moka), $api_url, true));
        // print_r($result); exit;
        if (!$result OR $result == NULL) {
            $record['result_code'] = 'CURL-LOAD_ERROR';
            $record['result_message'] = 'WebServis Error ';
            return $record;
        }

        if (isset($result->ResultCode) AND $result->ResultCode == "Success") {
            if ($result->Data->IsSuccessful) {
                $record['result_code'] = '99';
                $record['result_message'] = $result->ResultCode;
                $record['result'] = true;
                return $record;
            }
            $record['result_code'] = $result->Data->ResultCode;
            $record['result_message'] = $result->Data->ResultMessage;
            return $record;
        }
        $record['result_code'] = $result->ResultCode;
        $record['result_message'] = $result->ResultMessage != '' ? $result->ResultMessage : 'Payment Failed';
        return $record;
    }
    // 3DSecure
    $result = json_decode(eticsoft_mokagateway_curlPostExt(json_encode($moka), 'https://service.moka.com/PaymentDealer/DoDirectPaymentThreeD', true));
    if (!$result OR $result == NULL) {
        $record['result_code'] = 'CURL-LOAD_ERROR';
        $record['result_message'] = 'WebServis Error ';
        return $record;
    }

    if (isset($result->ResultCode) AND $result->ResultCode == "Success") {
        if ($result->Data) {
            header("Location:" . $result->Data);
        }
        $record['result_code'] = $result->Data->ResultCode;
        $record['result_message'] = $result->Data->ResultMessage;
        return $record;
    } else {
        $record['result_code'] = $result->ResultCode;
        $record['result_message'] = 'Payment Failed';
        return $record;
    }
}

function eticsoft_mokagateway_getAvailablePrograms()
{
    return array(
        'axess' => array('name' => 'Axess', 'bank' => 'Akbank A.Ş.'),
        'word' => array('name' => 'WordCard', 'bank' => 'Yapı Kredi Bankası'),
        'bonus' => array('name' => 'BonusCard', 'bank' => 'Garanti Bankası A.Ş.'),
        'cardfinans' => array('name' => 'CardFinans', 'bank' => 'FinansBank A.Ş.'),
        'maximum' => array('name' => 'Maximum', 'bank' => 'T.C. İş Bankası'),
        'paraf' => array('name' => 'Paraf', 'bank' => 'T Halk Bankası A.Ş.'),
        'ing' => array('name' => 'ING', 'bank' => 'ING Bank'),
        'advantage' => array('name' => 'Advantage', 'bank' => 'HSBC Bank'),
    );
}

function eticsoft_mokagateway_calculatePrices($price, $rates)
{
    for ($i = 1; $i <= 9; $i++) {
        $return[$i] = array(
            'total' => number_format((((100 + $rates[$i . '_installment']) * $price) / 100), 2, '.', ''),
            'monthly' => number_format((((100 + $rates[$i . '_installment']) * $price) / 100) / $i, 2, '.', ''),
        );
    }
    return $return;
}

function eticsoft_mokagateway_installments_form($params)
{

    $amount = eticsoft_mokagateway_getAmount($params['invoice']['balance']);
    $eticsoft_moka_params = eticsoft_mokagateway_getParams();
    $rates = eticsoft_mokagateway_calculatePrices($amount, $eticsoft_moka_params);

    $txt = 'Taksit Seçimi: <select name="eticsoft_moka_installment" class="select">';
    for ($ins = 1; $ins < 9; $ins++)
        if ($ins == 1)
            $txt .= '<option value="' . $ins . '">Tek Çekim'
                    . ' ' . $rates[key($rates)]['installments'][$ins]['total'] . '</option>';
        else
            $txt .= '<option value="' . $ins . '">' . $ins . ' taksit X ' . $rates[key($rates)]['installments'][$ins]['monthly']
                    . ' = ' . $rates[key($rates)]['installments'][$ins]['total'] . '</option>';
    $txt .= '</select>';

    return $txt;
}

add_hook('ClientAreaPageCreditCardCheckout', 1, function($vars) {
    $errormessage_eticsoft_moka = false;
    if (isset($_GET['tdvalidate']) AND $_GET['tdvalidate']) {
        $record = eticsoft_mokagateway_validate3d($vars);
        $errormessage_eticsoft_moka = 'Hata: (' . $record['result_code'] . ') ' . $record['result_message'];

        $result = $record['result'] ? 'success' : 'declined';

        logTransaction(
                'eticsoft_mokagateway', $record, $result
        );
        if ($record['result']) {
            $fee = (float) ($record['amount'] - (eticsoft_mokagateway_getAmount($vars['invoice']['balance'])));
            addInvoicePayment(
                    $vars['invoice']['id'], $record['orderId'], eticsoft_mokagateway_getAmount($vars['invoice']['balance']), $fee, 'eticsoft_mokagateway'
            );
            redir("id=" . $vars['invoice']['id'], "viewinvoice.php");
        }
    }
    $amount = eticsoft_mokagateway_getAmount($vars['invoice']['balance']);
    $eticsoft_moka_params = eticsoft_mokagateway_getParams();
    return array(
        "pagetitle" => $vars['filename'],
        "installments" => eticsoft_mokagateway_calculatePrices($amount, $eticsoft_moka_params),
        "errormessage_eticsoft_moka" => $errormessage_eticsoft_moka
    );
}
);

add_hook('ClientAreaPageCart', 1, function($vars) {
    if ($_GET['a'] != "checkout")
        return;
    $amount = eticsoft_mokagateway_getAmount($vars['total']);
    $eticsoft_moka_params = eticsoft_mokagateway_getParams();
    return array(
        "installments" => eticsoft_mokagateway_calculatePrices($amount, $eticsoft_moka_params),
        "eticsoft_moka_currency" => preg_replace("/[^a-zA-Z]+/", "", $vars['total'])
    );
}
);

add_hook('ShoppingCartValidateCheckout', 1, function($vars) {
    if (isset($_POST['eticsoft_moka_installment'])) {
        $_SESSION['eticsoft_moka_installment'] = (int) $_POST['eticsoft_moka_installment'];
    }
}
);

function eticsoft_mokagateway_getAmount($money)
{
    $cleanString = preg_replace('/([^0-9\.,])/i', '', $money);
    $onlyNumbersString = preg_replace('/([^0-9])/i', '', $money);

    $separatorsCountToBeErased = strlen($cleanString) - strlen($onlyNumbersString) - 1;

    $stringWithCommaOrDot = preg_replace('/([,\.])/', '', $cleanString, $separatorsCountToBeErased);
    $removedThousendSeparator = preg_replace('/(\.|,)(?=[0-9]{3,}$)/', '', $stringWithCommaOrDot);

    return (float) str_replace(',', '.', $removedThousendSeparator);
}

function eticsoft_mokagateway_curlPostExt($data, $url, $json = false)
{
    $ch = curl_init(); // initialize curl handle
    curl_setopt($ch, CURLOPT_URL, $url); // set url to post to
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); // return into a variable
    if ($json)
        curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-type: application/json"));
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($ch, CURLOPT_TIMEOUT, 30); // times out after 4s
    curl_setopt($ch, CURLOPT_POST, 1); // set POST method
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data); // add POST fields
    if ($result = curl_exec($ch)) { // run the whole process
        curl_close($ch);
        return $result;
    }
    return false;
}
